package app18a.action;

import app18a.dao.CustomerDAO;
import app18a.dao.DAOFactory;
import app18a.form.CustomerSearchCriteriaForm;
import app18a.to.CustomerSearchCriteriaTO;
//import org.displaytag.pagination.NumberedPage;

import java.util.ArrayList;
//import java.util.Enumeration;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

public class SearchCustomerAction extends Action {

  public ActionForward execute(ActionMapping mapping, ActionForm form,
    HttpServletRequest request, HttpServletResponse response) {

    HttpSession session = request.getSession();
    if (session.getAttribute("customerList")==null ||
      request.getMethod().equalsIgnoreCase("POST")) {
      CustomerSearchCriteriaForm customerForm = (CustomerSearchCriteriaForm) form;
      CustomerSearchCriteriaTO customerSearch = new CustomerSearchCriteriaTO();
      customerSearch.setName(customerForm.getName()); 	
      customerSearch.setAddress(customerForm.getAddress());   
      customerSearch.setPhone(customerForm.getPhone());
      CustomerDAO customerDAO = DAOFactory.getInstance().getCustomerDAO();
      try {
      	ArrayList customerList = customerDAO.searchCustomers(customerSearch);
       	session.setAttribute("customerList", customerList);       	
      }
      catch (Exception ex) {
        ActionMessages actionMessages = new ActionMessages();          
        actionMessages.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("failed.search"));
        saveMessages(request, actionMessages);
      	return (mapping.findForward("failed"));
      } 
    }
    return mapping.getInputForward();
  }
}
