package app18b.dao;

import app18b.to.CustomerSearchCriteriaTO;
import app18b.to.CustomerTO;

import java.util.ArrayList;

public interface CustomerDAO {
  public void createCustomer(CustomerTO customer) throws DAOException;
  public void updateCustomer(CustomerTO customer) throws DAOException;
  public CustomerTO getCustomer(int customerId) throws DAOException;
  public void deleteCustomer(int customerID) throws DAOException;
  public ArrayList searchCustomers(CustomerSearchCriteriaTO searchCriteria, int recordStart, int maxRecordsPerRetrieve) throws DAOException;
}
